/*
 * Copyright (C) 2009 JavaRosa
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

/**
 * 
 */
package org.javarosa.activity.splashscreen;

import java.io.IOException;

import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Image;

import org.javarosa.core.Context;
import org.javarosa.core.JavaRosaServiceProvider;
import org.javarosa.core.api.Constants;
import org.javarosa.core.api.IActivity;
import org.javarosa.core.api.ICommand;
import org.javarosa.core.api.IShell;
import org.javarosa.core.api.IView;
import org.javarosa.j2me.view.J2MEDisplay;

import de.enough.polish.ui.splash.ApplicationInitializer;
import de.enough.polish.ui.splash.InitializerSplashScreen;

/**
 * @author Brian DeRenzi
 *
 */
public class SplashScreenActivity implements IActivity, ApplicationInitializer {

	private IShell parent = null;
	private String picture = null;
	private int splashDelay = 2000;
	
	Context context;
	
	public SplashScreenActivity(IShell p, String pic) {
		this.parent = p;
		this.picture = pic;
	}
	
	/* (non-Javadoc)
	 * @see org.javarosa.module.IModule#start()
	 */
	public void start(Context context) {
		try {
			// TODO Auto-generated method stub
			Image image = Image.createImage(this.picture);
			int backgroundColor = 0xFFFFFF;
			String readyMessage = "Press any key to continue...";
			//Set readyMessage = null to forward to the next
			//displayabe as soon as it's available
			int messageColor = 0xFF0000;
			final InitializerSplashScreen splashScreen = new InitializerSplashScreen(((J2MEDisplay)JavaRosaServiceProvider.instance().getDisplay()).getDisplay(),
					image, backgroundColor, readyMessage, messageColor, this){};
			parent.setDisplay(this, new IView() {
				public Object getScreenObject() {
					return splashScreen;
				}} );
			this.context = context;
			} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	
	/* (non-Javadoc)
	 * @see de.enough.polish.ui.splash.ApplicationInitializer#initApp()
	 */
	public Displayable initApp() {
		// TODO Auto-generated method stub
		try{
  		  Thread.sleep(this.splashDelay);
  		} catch(Exception e) {}
  		
  		// Tell the shell that the splash screen has completed
  		parent.returnFromActivity(this, Constants.ACTIVITY_COMPLETE, null);
  		
  		// We're using our own architecture
		return null;
	}

	
	/**
	 * @return the splashDelay
	 */
	public int getSplashDelay() {
		return this.splashDelay;
	}

	/**
	 * @param splashDelay the splashDelay to set
	 */
	public void setSplashDelay(int splashDelay) {
		this.splashDelay = splashDelay;
	}
	
	public void contextChanged(Context globalContext) {
		//don't bother. we don't need context
	}
	
	public void halt() {
	}
	
	public void resume(Context context) {
		start(context);
	}
	
	public void destroy() {
		
	}
	
	public Context getActivityContext() {
		return context;
	}
	/*
	 * (non-Javadoc)
	 * @see org.javarosa.core.api.IActivity#setShell(org.javarosa.core.api.IShell)
	 */
	public void setShell(IShell shell) {
		this.parent = shell;
	}
	/* (non-Javadoc)
	 * @see org.javarosa.core.api.IActivity#annotateCommand(org.javarosa.core.api.ICommand)
	 */
	public void annotateCommand(ICommand command) {
		throw new RuntimeException("The Activity Class " + this.getClass().getName() + " Does Not Yet Implement the annotateCommand Interface Method. Please Implement It.");
	}
}
