/*
 * Copyright (C) 2009 JavaRosa
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

/**
 * 
 */
package org.javarosa.cases.util;

import org.javarosa.cases.model.Case;
import org.javarosa.cases.storage.CaseRmsUtility;
import org.javarosa.core.JavaRosaServiceProvider;
import org.javarosa.core.services.storage.utilities.IRecordStoreEnumeration;

/**
 * @author Clayton Sims
 * @date May 18, 2009 
 *
 */
public class CaseRestorableTest {
	public static void test() {
		CaseRmsUtility utility = (CaseRmsUtility)JavaRosaServiceProvider.instance().getStorageManager().getRMSStorageProvider().getUtility(CaseRmsUtility.getUtilityName());
		for (IRecordStoreEnumeration en = utility.enumerateMetaData(); en.hasNextElement(); ) {
			Case c = new Case();
			try {
				utility.retrieveFromRMS(en.nextRecordId(), c);
				RestorableTestHarness.evaluateRestorable(c);
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException("Case was busted!");
			}
		}
	}
}
